/*! Monio: iox.mjs
    v0.53.0 (c) 2024 Kyle Simpson
    MIT License: http://getify.mit-license.org
*/
const GLOBAL="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof global?global:"undefined"!=typeof window?window:"undefined"!=typeof self?self:new Function("return this")();import{EMPTY_FUNC,identity,isFunction,isPromise,isMonad,curry,getDeferred,definePipeWithMethodChaining,definePipeWithAsyncFunctionComposition,continuation,returnSignal,isReturnSignal,trampoline}from"../lib/util.mjs";import Either from"../either.mjs";import IO from"./io.mjs";onEvent=curry(onEvent,2),onceEvent=curry(onceEvent,2),of.empty=ofEmpty;var registeredPromiseCatches=new WeakSet,registerHooks=new WeakMap,ioxErrorCallbacks=new WeakMap,ioxConnections=new Map,ioxReverseConnections=new Map;const BRAND={},EMPTY=Symbol("empty"),UNSET=Symbol("unset"),CLOSED=Symbol("closed"),NEVER=Symbol("never"),EMPTY_IO=IO.of(),IOis=IO.is,IO_is=EMPTY_IO._is,NeverIOx=defineNeverIOx();export default Object.assign(IOx,{of:of,pure:of,unit:of,is:is,do:$do,doEither:doEither,debounce:debounce,onEvent:onEvent,onceEvent:onceEvent,onTimer:onTimer,merge:merge,zip:zip,fromIO:fromIO,fromIter:fromIter,toIter:toIter,fromObservable:fromObservable,Never:NeverIOx});export{of};export{of as pure};export{of as unit};export{is};export{$do as do};export{doEither};export{debounce};export{onEvent};export{onceEvent};export{onTimer};export{merge};export{zip};export{fromIO};export{fromIter};export{toIter};export{fromObservable};export{NeverIOx as Never};function IOx(e,n=[]){n=Array.isArray(n)?[...n]:[n];const r=IOx$.bind;var t,i,o,s=UNSET,u=UNSET,c=new WeakMap,a=new WeakMap,l=new WeakSet,f=new WeakSet,p=!1,d=!1,h=!1,E=!1,g=0,O=IO((function effect(r){if(!E&&isFunction(e)){var o=continuation();return p||h||o.push((()=>function registerWithDeps(e){if(Array.isArray(n)&&n.length>0){p=!0;for(let e of n)is(e)&&addIOxConnection(e,v);return registerDep(n)}registrationComplete();function registerDep([n,...r]){if(u===NEVER)return registrationComplete();var t=r.length>0?()=>registerDep(r):registrationComplete;if(is(n)&&registerHooks.has(n)&&!c.has(n)){c.set(n,[]);let[r]=registerHooks.get(n);return continuation((()=>r(onDepUpdate,e)),t)}return continuation(t)}function registrationComplete(){p=!1,h=!0}}(r))),o.push((()=>function execIOF(r){return d?void 0:checkDepsAndExecute(UNSET,!0);function checkDepsAndExecute(n,o){if(u===NEVER)return getDeferred().pr;var c;if(d=!0,!E&&e&&(s=r,c=collectDepVals(r,o)),c){if(c===NEVER)return commitIOFResult(NEVER,UNSET);if(c===CLOSED||!e)try{return(n!==UNSET?n:void 0)||t||getDeferred().pr}finally{close(),d=!1}}else try{return n!==UNSET?n:(t||({pr:t,next:i}=getDeferred()),t)}finally{discardCurrentIODepVals(),d=!1}return continuation((()=>e(s,...c)),(e=>commitIOFResult(e,n)))}function commitIOFResult(e,r){if(u!==NEVER){if(!E&&e!==EMPTY)return continuation((()=>updateCurrentVal(e,function haveQueuedIOxDepVals(){if(haveDeps())for(let e of n)if(is(e)){let n=c.get(e);if(n&&n.length>1)return!0}return!1}())),settleUpdate);try{return[UNSET,CLOSED,NEVER].includes(r)?void 0:r}finally{discardCurrentIODepVals(),d=!1}}else d=!1}function settleUpdate(e){if(!isPromise(e)&&haveIOxDeps())return function discardCurrentIOxDepVals(){if(haveDeps())for(let e of n)is(e)&&removeDepVal(e)}(),checkDepsAndExecute(e,!1);!function discardCurrentDepVals(){if(haveDeps())for(let e of n)removeDepVal(e),l.delete(e)}();try{if(haveIOxDeps())for(let r of n)if(isClosedIOx(r))return continuation((()=>close(returnSignal())),(()=>e));return e}finally{discardCurrentIODepVals(),d=!1}}}(r))),o}if(![UNSET,CLOSED].includes(u))return u})),v=Object.assign(IOx$,{map:function map(e){return u===NEVER?NeverIOx:IOx(((n,r)=>e(r)),[v])},chain:chain,flatMap:chain,bind:chain,ap:function ap(e){return u===NEVER?NeverIOx:IOx(((n,r)=>e.map(r).run(returnSignal(n))),[v])},concat:function concat(e){return u===NEVER?NeverIOx:IOx(((n,r)=>continuation((()=>e.run(returnSignal(n))),(e=>isPromise(e)?e.then((e=>r.concat(e))):r.concat(e)))),[v])},run:function run(e){if(u===NEVER)return;if(!E)try{return checkRunRes(isReturnSignal(e)?continuation((()=>O.run(e)),checkRunRes):trampoline(O.run(returnSignal(e))))}catch(e){throw notifyIOxError(v,e),e}},stop:stop,close:close,isClosed:function isClosed(){return E},never:function never(){E||u===NEVER||assign(NEVER)},isNever:function isNever(){return!E&&u===NEVER},toString:function toString(){return u===NEVER?NeverIOx.toString():`[function ${this[Symbol.toStringTag]||this.name}]`},onError:function onError(e){ioxErrorCallbacks.has(v)||ioxErrorCallbacks.set(v,new Set);return ioxErrorCallbacks.get(v).add(e),v},offError:function offError(e){ioxErrorCallbacks.has(v)&&ioxErrorCallbacks.get(v).delete(e);return v},_chain_with_IO:function _chain_with_IO(e){return u===NEVER?EMPTY_IO:u!==UNSET&&s!==UNSET?e(u):O?O.chain(e):e(void 0)},_inspect:function _inspect(){return u===NEVER?NeverIOx._inspect():E?"IOx(-closed-)":`${this[Symbol.toStringTag]}(${isMonad(u)&&isFunction(u._inspect)?u._inspect():[UNSET,CLOSED].includes(u)?e.name||"anonymous function":String(u)})`},_bind:r,_is:function _is(e){return!(e!==BRAND&&!IO_is(e))},[Symbol.toStringTag]:"IOx"});return definePipeWithAsyncFunctionComposition(v,"map"),definePipeWithMethodChaining(v,"chain"),definePipeWithMethodChaining(v,"ap"),definePipeWithMethodChaining(v,"concat"),registerHooks.set(v,[registerListener,unregisterListener]),v;function IOx$(e){assign(e)}function checkRunRes(e){return isPromise(e)&&!registeredPromiseCatches.has(e)&&(registeredPromiseCatches.add(e),e.catch((e=>notifyIOxError(v,e)))),e}function stop(){u!==NEVER&&(unregisterWithDeps(),s=UNSET)}function close(r){if(u!==NEVER&&!E){E=!0,stop(),removeIOxConnections(v);let s=continuation((()=>{try{return updateCurrentVal(CLOSED,!1)}finally{registerHooks.delete(v),l=t=i=f=n=e=O=v=o=null}}));return isReturnSignal(r)?s:trampoline(s)}}function assign(r){if(!E&&u!==NEVER)if(unregisterWithDeps(),n=s=e=null,isPromise(r)){let e=updateCurrentVal(r,!1);registeredPromiseCatches.has(e)||(registeredPromiseCatches.add(e),e.catch((e=>notifyIOxError(v,e))))}else trampoline(updateCurrentVal(r,!1))}function chain(e){if(u===NEVER)return NeverIOx;var n=IOx(((n,r)=>{var t=e(r);return isPromise(t)?t.then((e=>trampoline(handle(e,n)))):handle(t,n)}),[v]);return n;function handle(e,r){if(u===NEVER||e===NeverIOx||is(e)&&e.isNever())return getDeferred().pr;var t=function checkClosedIOx(e){if(isClosedIOx(e)&&n&&!n.isClosed())return continuation((()=>n.close(returnSignal())),cleanup)}(e);return void 0!==t?t:is(e)&&registerHooks.has(e)&&f&&!f.has(e)?(addIOxConnection(e,v),f.add(e),continuation((()=>registerListener((function listener(n,r){if(r!==NEVER)return r===CLOSED&&e&&!e.isClosed()?(unregisterListener(listener),continuation((()=>e.close(returnSignal())),cleanup)):void 0;unregisterListener(listener)}),s!==UNSET?s:r)),(()=>{var[t,i]=registerHooks.get(e);return continuation((()=>t((function listener(e,r){if(r!==NEVER)return r===CLOSED&&n&&!n.isClosed()?(i(listener),continuation((()=>n.close(returnSignal())),cleanup)):void 0;i(listener)}),s!==UNSET?s:r)),runReturnedIO)}))):runReturnedIO();function runReturnedIO(){return e.run(returnSignal(r))}function cleanup(){f&&e&&f.delete(e),n=e=null}}}function haveDeps(){return Array.isArray(n)&&n.length>0}function haveIOxDeps(){if(haveDeps())return n.some(is)}function isClosedIOx(e){return is(e)&&e.isClosed()}function discardCurrentIODepVals(){if(haveDeps())for(let e of n)IOis(e)&&!is(e)&&removeDepVal(e)}function onDepUpdate(e,n){if(u!==NEVER){if(n===NEVER)return updateCurrentVal(NEVER,!1);if(n===CLOSED?a.delete(e):setDepVal(e,n),!p&&!d){if(s!==UNSET&&n!==CLOSED)return v.run(returnSignal(s));if(collectDepVals(void 0,!1)===CLOSED)return close(returnSignal())}}}function setDepVal(e,n){c.has(e)||c.set(e,[]),c.get(e).push(n),is(e)&&a.set(e,n)}function getDepVal(e){return c.get(e)[0]}function hasDepVal(e){return c.has(e)&&c.get(e).length>0}function removeDepVal(e){hasDepVal(e)&&c.get(e).shift()}function collectDepVals(e,r){if(!haveDeps())return[];if(++g>1)return!1;for(var t;g>0;){t=[];for(let e of n){if([NEVER,NeverIOx].includes(e))return g=0,NEVER;if(isClosedIOx(e)&&(!d||!hasDepVal(e)))return g=0,CLOSED}for(let i of n)if(is(i)){let e=hasDepVal(i)?getDepVal(i):r&&a.has(i)?a.get(i):UNSET;t.push(e)}else if(IOis(i))if(l&&l.has(i))t.push(UNSET);else if(hasDepVal(i))t.push(getDepVal(i));else{let n=trampoline(i.run(returnSignal(e||(s!==UNSET?s:void 0))));if(isPromise(n)){l.add(i),t.push(UNSET);let e=n.then((e=>{l&&l.has(i)&&(l.delete(i),trampoline(onDepUpdate(i,e)))}));registeredPromiseCatches.has(e)||(registeredPromiseCatches.add(e),e.catch((e=>notifyIOxError(v,e))))}else l.delete(i),setDepVal(i,n),t.push(n)}else i===EMPTY?t.push(UNSET):t.push(i);t.includes(UNSET)&&(t=!1),g=Math.max(0,g-1)}return Array.isArray(t)&&t.length>0?t:void 0}function updateCurrentVal(r,c){if(isPromise(r)){let e=r.then((e=>trampoline(handleValue(e))));return registeredPromiseCatches.has(e)||(registeredPromiseCatches.add(e),e.catch((e=>notifyIOxError(v,e)))),e}return c=!1,handleValue(r);function handleValue(e){return u!==NEVER&&(u=e),Array.isArray(o)&&o.length>0?notifyListeners(v,u,o):checkIOxQueue()}function notifyListeners(e,n,[r,...t]){return continuation((()=>r(e,n)),t.length>0?()=>notifyListeners(e,n,t):checkIOxQueue)}function checkIOxQueue(){return u!==NEVER&&c&&!d&&s!==UNSET?continuation((()=>v.run(returnSignal(s))),completeUpdate):completeUpdate()}function completeUpdate(){var depsHaveFinished=()=>{i&&(i(u),t=i=null)};return u===NEVER?void(!E&&e&&(unregisterWithDeps(),l=t=i=f=n=e=O=v=o=null)):u===CLOSED?(O&&close(),void depsHaveFinished()):(depsHaveFinished(),u)}}function registerListener(e,n){return[NEVER,CLOSED].includes(u)?e(v,u):(Array.isArray(o)?o.push(e):o=[e],s===UNSET?v.run(returnSignal(n)):u!==UNSET?e(v,u):void 0)}function unregisterListener(e){if(Array.isArray(o)&&o.length>0){let n=o.findIndex((n=>n==e));o.splice(n,1)}}function unregisterWithDeps(){if(h=!1,haveDeps()){for(let e of n)if(e&&isFunction(e)&&registerHooks.has(e)){c.delete(e),l&&l.delete(e);let[,n]=registerHooks.get(e);n(onDepUpdate)}c=new WeakMap,a=new WeakMap}}}function is(e){return!!(e&&isFunction(e._is)&&e._is(BRAND))}function of(e){return arguments.length>0?IOx((()=>e),[]):ofEmpty()}function ofEmpty(){return IOx(EMPTY_FUNC,[EMPTY])}function $do(e,n,...r){return IOx(((n,...t)=>IO.do(e,...t,...r).run(n)),n)}function doEither(e,n,...r){return IOx(((n,...t)=>IO.doEither(e,...t,...r).run(n)),n)}function debounce(e,n=0){var r,t;e=Math.max(Number(e)||0,0),(n=Math.max(Number(n)||0,0))>0&&n<=e&&(n=e+1),0==n&&(n=null);var i=[];return function debounce(o){i.push(IOx.of.empty());var s=i[i.length-1];null==r&&(r=Date.now());var u=Date.now(),c=null==n?e:Math.min(e,n-(u-r));return null!=t&&(clearTimeout(t),t=null),t=setTimeout((()=>{var e=i.slice(0,-1);s=i[i.length-1],i.length=0;for(let n of e)n.never();s.isClosed()||s(o),r=t=null}),c),s}}function onEvent(e,n,r){if(r&&r.fromOnceEvent)r=r.fromOnceEvent;else if(r&&r.evtOpts&&r.evtOpts.once)return onceEvent(e,n,r);var{debounce:t=0,maxDebounceDelay:i=0,evtOpts:o}=r||{};t=Number(t)||0,i=Math.max(t,Number(i)||0);var s=!1,u=IOx((function effect(){return subscribe(),EMPTY}),[]),c=t>0?u.chain(debounce(t,i)):u,{run:a,stop:l,close:f}=c;return Object.assign(c,{run:run,stop:stop,close:function close(n){if(u){Object.assign(c,{run:a,stop:l,close:f}),stop();let t=continuation((()=>{try{return u.close(n)}finally{run=a=l=stop=f=c=u=e=r=o=null}}));return isReturnSignal(n)?t:trampoline(t)}}}),c;function subscribe(){!s&&u&&(s=!0,isFunction(e.addEventListener)?e.addEventListener(n,u,o):isFunction(e.addListener)?e.addListener(n,u):isFunction(e.on)&&e.on(n,u))}function run(e){if(a)return subscribe(),a(e)}function stop(){!function unsubscribe(){s&&u&&(s=!1,isFunction(e.removeEventListener)?e.removeEventListener(n,u,o):isFunction(e.removeListener)?e.removeListener(n,u):isFunction(e.off)&&e.off(n,u))}(),c!==u?u.stop():l()}}function onceEvent(e,n,r){var t,{evtOpts:i}=r||{};i||(i={}),i.once=!0;var o=!1,s=!1,u=onEvent(e,n,{fromOnceEvent:r}),{run:c,stop:a,close:l}=u;return Object.assign(u,{run:run,stop:stop,close:close}),u;function run(e){if(u&&(c&&(u.run=c),function subscribe(){o||t||!u||(o=!0,t=IOx(onFire,[u]))}(),t))return t.run(e)}function stop(){u&&(u.run=run,function unsubscribe(){o&&t&&(o=!1,t.close(),t=null)}(),a())}function close(e){if(u){Object.assign(u,{run:c,stop:a,close:l}),stop();let n=continuation((()=>{try{return u.close(e)}finally{run=c=a=stop=l=close=u=t=r=i=null}}));return isReturnSignal(e)?n:trampoline(n)}}function onFire(){s||(s=!0,close())}}function onTimer(e,n){var r,t=!1,i=IOx((function effect(){return subscribe(),EMPTY}),[]);n="number"==typeof n?Math.max(1,n||1):void 0;var{run:o,stop:s,close:u}=i;return Object.assign(i,{run:run,stop:stop,close:close}),i;function subscribe(){t||r||(t=!0,r=setInterval(onTick,e))}function run(e){if(subscribe(),o)return o(e)}function onTick(){i&&i("tick"),"number"==typeof n&&(n--,close&&n<=0&&close())}function stop(){!function unsubscribe(){t&&r&&(t=!1,clearInterval(r),r=null)}(),s()}function close(e){if(i){Object.assign(i,{run:o,stop:s,close:u}),stop();let n=continuation((()=>{try{return i.close(e)}finally{run=o=s=stop=u=close=i=null}}));return isReturnSignal(e)?n:trampoline(n)}}}function zip(e=[]){Array.isArray(e)&&(e=[...e]);var n=!1,r=new Map,t=IOx((function effect(e){return continuation((()=>subscribe(e)),(()=>EMPTY))}),[]),{run:i,stop:o,close:s}=t;return Object.assign(t,{run:run,stop:stop,close:close}),t;function subscribe(r){if(!n&&t&&(n=!0,Array.isArray(e)&&e.length>0))return subscribeToIOxs(e,r)}function subscribeToIOxs([e,...n],i){return addIOxConnection(e,t),continuation((()=>{if(r.has(e)||r.set(e,[]),registerHooks.has(e)){let[n]=registerHooks.get(e);return n(onUpdate,i)}}),n.length>0?()=>subscribeToIOxs(n,i):checkListeners)}function onUpdate(e,n){if(t&&!t.isClosed())return n!==CLOSED&&r.has(e)&&r.get(e).push(n),checkListeners()}function checkListeners(){if(t&&!t.isClosed()&&Array.isArray(e))for(;;){let n,i,o=!0;for(let t of e){t&&!t.isClosed()&&(o=!1);let e=r.get(t);if(e.length>0)i=i||[],n=n||[],i.push(e[0]),n.push(e);else if(t&&!t.isClosed())return}if(!(Array.isArray(i)&&Array.isArray(n)&&i.length>0&&n.length>0))return o?close(returnSignal()):void 0;for(let e of n)e.shift();t(i)}}function run(e){if(i){let n=continuation((()=>subscribe(e)),(()=>i(e)));return isReturnSignal(e)?n:trampoline(n)}}function stop(){!function unsubscribe(){if(n&&t&&(n=!1,Array.isArray(e)&&e.length>0))for(let n of e)if(registerHooks.has(n)){let[,e]=registerHooks.get(n);e(onUpdate)}}(),o()}function close(n){if(t){Object.assign(t,{run:i,stop:o,close:s}),stop();let u=continuation((()=>{try{return t.close(n)}finally{run=i=o=stop=s=close=r=t=e=null}}));return isReturnSignal(n)?u:trampoline(u)}}}function merge(e=[]){Array.isArray(e)&&(e=[...e]);var n=!1,r=IOx((function effect(e){return continuation((()=>subscribe(e)),(()=>EMPTY))}),[]),{run:t,stop:i,close:o}=r;return Object.assign(r,{run:run,stop:stop,close:close}),r;function subscribe(t){if(!n&&r&&(n=!0,Array.isArray(e)&&e.length>0))return subscribeToIOxs(e,t)}function subscribeToIOxs([e,...n],t){return addIOxConnection(e,r),continuation((()=>{if(registerHooks.has(e)){let[n]=registerHooks.get(e);return n(onUpdate,t)}}),n.length>0?()=>subscribeToIOxs(n,t):checkListeners)}function onUpdate(e,n){if(r&&!r.isClosed())return n!==CLOSED&&r(n),checkListeners()}function checkListeners(){if(r&&!r.isClosed()&&Array.isArray(e)&&e.length>0&&e.every((e=>!e||e.isClosed())))return close(returnSignal())}function run(e){if(t){let n=continuation((()=>subscribe(e)),(()=>t(e)));return isReturnSignal(e)?n:trampoline(n)}}function stop(){!function unsubscribe(){if(n&&r&&(n=!1,Array.isArray(e)))for(let n of e)if(registerHooks.has(n)){let[,e]=registerHooks.get(n);e(onUpdate)}}(),i()}function close(n){if(r){Object.assign(r,{run:t,stop:i,close:o}),stop();let s=continuation((()=>{try{return r.close(n)}finally{run=t=i=stop=o=close=r=e=null}}));return isReturnSignal(n)?s:trampoline(s)}}}function fromIO(e){return IOx(((e,n)=>n),[e])}function fromIter(e,n=!0){Symbol("paused");var r,t,i,o=!1,s=this,u=IOx((function effect(){return function subscribe(){if(!o&&u){o=!0,i=function getIter(e){return isFunction(e)?e.call(s):e&&isFunction(e.next)?e:e&&e[Symbol.iterator]?e[Symbol.iterator]():e&&e[Symbol.asyncIterator]?e[Symbol.asyncIterator]():void 0}(e),({pr:t,next:r}=getDeferred());let c=async function drainIterator(){var e=!0;try{for(;o;){let n=i.next();if(isPromise(n)&&(n=await Promise.race([t,n])),!n)break;if(n===CLOSED||!o||n.done)break;if(isPromise(n.value)){if(n=await Promise.race([t,n.value]),n===CLOSED||!e)break;u(n)}else u(n.value)}}finally{e=!1,n&&close?close():await unsubscribe()}}();registeredPromiseCatches.has(c)||(registeredPromiseCatches.add(c),c.catch((e=>notifyIOxError(u,e))))}}(),EMPTY}),[]),{run:c,stop:a,close:l}=u;return Object.assign(u,{run:run,stop:stop,close:close}),u;function unsubscribe(){o&&u&&(r(CLOSED),t=r=null,o=!1)}function run(e){if(c)return c(e)}function stop(){unsubscribe(),a()}function close(e){if(u){Object.assign(u,{run:c,stop:a,close:l}),stop();let n=continuation((()=>{try{return u.close(e)}finally{run=c=a=stop=l=close=u=null}}));return isReturnSignal(e)?n:trampoline(n)}}}function toIter(e,n){var r,t=[],i=[],o=!1,s=!1,u={[Symbol.asyncIterator](){return this},next:doNext,return:doReturn,start:subscribe,nextIO:function nextIO(){return IO((()=>doNext()))},isClosed:function isClosed(){return o}};return u;function emptyResult(e){return{value:e,done:!0}}function primeQueues(){var{pr:e,next:n}=getDeferred();t.push(e),i.push(n)}function subscribe(){if(!s&&registerHooks.has(e)){s=!0;let[r]=registerHooks.get(e);trampoline(r(onIOxUpdate,n))}}function onIOxUpdate(e,n){if(n===CLOSED)0==t.length&&doReturn();else if(!o){0==i.length&&primeQueues(),i.shift()({value:n,done:!1})}}function doNext(){if(o)return Promise.resolve(emptyResult());if(e.isClosed()&&0==t.length)return doReturn();0==t.length&&primeQueues();var n=t.shift();return s||subscribe(),n}function doReturn(s){var c=emptyResult(s);if(!o){if(o=!0,function unsubscribe(){if(registerHooks.has(e)){let[,n]=registerHooks.get(e);n(onIOxUpdate)}}(),r=t.length>0?t[t.length-1]:void 0,i.length>0)for(let e of i)e(emptyResult());i=t=n=e=u=null}return r?r.then((()=>{try{return c}finally{r=c=null}})):Promise.resolve(c)}}function fromObservable(e){var n=null,r=IOx((function effect(){return subscribe(),EMPTY}),[]),{run:t,stop:i,close:o}=r;return Object.assign(r,{run:run,stop:stop,close:close}),r;function subscribe(){!n&&r&&(n=e.subscribe({next:e=>r(e),error:e=>notifyIOxError(r,e),complete:close}))}function run(e){if(t)return subscribe(),t?t(e):void 0}function stop(){!function unsubscribe(){n&&(n.unsubscribe(),n=null)}(),i()}function close(s){if(r){Object.assign(r,{run:t,stop:i,close:o}),stop();let u=continuation((()=>{try{return r.close(s)}finally{run=t=i=stop=o=close=r=e=n=null}}));return isReturnSignal(s)?u:trampoline(u)}}}function addIOxConnection(e,n){ioxConnections.has(e)||ioxConnections.set(e,new Set);var r=ioxConnections.get(e);r.add(n),ioxReverseConnections.has(n)||ioxReverseConnections.set(n,new Set),ioxReverseConnections.get(n).add(r)}function removeIOxConnections(e){if(ioxConnections.delete(e),ioxReverseConnections.has(e)){ioxReverseConnections.get(e).forEach((n=>n.delete(e))),ioxReverseConnections.delete(e)}}function notifyIOxError(e,n){for(var r=!1,t=[e];t.length>0;){let e=t.shift();if(ioxErrorCallbacks.has(e))for(let t of ioxErrorCallbacks.get(e))try{t(n),r=!0}catch(e){logUnhandledError(e)}!r&&ioxConnections.has(e)&&t.push(...ioxConnections.get(e))}r||logUnhandledError(n)}function logUnhandledError(e){(isFunction(GLOBAL.reportError)?e=>GLOBAL.reportError(e instanceof Error?e:new Error(e)):e=>isFunction(console.error)?console.error((Error,e)):console.log(e instanceof Error?e:isFunction(e.toString)?e.toString():String(e)))(Either.Left.is(e)?e.fold(identity,EMPTY_FUNC):isMonad(e)&&isFunction(e._inspect)?e._inspect():e)}function defineNeverIOx(){const e="NeverIOx",n=NeverIOx$.bind;var r=Object.assign(NeverIOx$,{map:NeverIOx$,chain:NeverIOx$,flatMap:NeverIOx$,bind:NeverIOx$,concat:NeverIOx$,run:EMPTY_FUNC,stop:EMPTY_FUNC,close:EMPTY_FUNC,isClosed:function isClosed(){return!1},never:NeverIOx$,isNever:function isNever(){return!0},toString:function toString(){return`[function ${this[Symbol.toStringTag]||this.name}]`},onError:EMPTY_FUNC,offError:EMPTY_FUNC,_chain_with_IO:function _chain_with_IO(){return EMPTY_IO},_inspect:function _inspect(){return`${e}()`},_bind:n,_is:IOx.is,[Symbol.toStringTag]:e});return registerHooks.set(r,[EMPTY_FUNC,EMPTY_FUNC]),NeverIOx$.pipe=NeverIOx$,r;function NeverIOx$(){return r}}